<template>
  <v-btn prepend-icon="mdi-account-plus" :disabled="showDialog" @click="openDialog()">
    Benutzer hinzufügen
  </v-btn>

  <v-dialog v-model="showDialog" max-width="600">
    <v-card prepend-icon="mdi-account" title="Benutzer hinzufügen">
      <v-card-text>
        <v-row dense>
          <v-col cols="12" md="6" sm="12">
            <v-text-field
              label="Vorname:*"
              v-model="form.firstName"
              :rules="formErrors.firstName"
              required
            ></v-text-field>
          </v-col>

          <v-col cols="12" md="6" sm="12">
            <v-text-field
              label="Nachname:*"
              v-model="form.lastName"
              :rules="formErrors.lastName"
              required
            ></v-text-field>
          </v-col>

          <v-col cols="12">
            <v-text-field
              label="E-Mail Adresse:*"
              v-model="form.email"
              :rules="formErrors.email"
              :error-messages="emailExistsError ? 'Diese E-Mail existiert bereits!' : ''"
              @update:modelValue="emailExistsError = false"
              required
            ></v-text-field>
          </v-col>

          <v-col cols="12">
            <v-text-field
              label="Telefon-Nummer:"
              v-model="form.phoneNumber"
              type="tel"
            ></v-text-field>
          </v-col>

          <v-col cols="12">
            <v-select
              v-model="form.roleIds"
              :items="roles"
              item-title="name"
              item-value="id"
              label="Rollen:"
              clearable
              chips
              multiple
            >
            </v-select>
          </v-col>
        </v-row>

        <small class="text-caption text-medium-emphasis">
          *kennzeichnet ein Pflichtfeld
        </small>
      </v-card-text>

      <v-divider></v-divider>

      <v-card-actions>
        <v-spacer></v-spacer>

        <div class="d-flex flex-row justify-space-between w-100">
          <v-btn text="Abbrechen" color="error" @click="showDialog = false"></v-btn>

          <v-btn
            text="Benutzer erstellen"
            color="success"
            :disabled="isFormInvalid()"
            @click="submitForm()"
          ></v-btn>
        </div>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script setup lang="ts">
import { AxiosError } from "axios";
import { onMounted, ref } from "vue";
import { RoleResponse, UserBody, api } from "../api";

const emits = defineEmits<{ (event: "submitted"): void }>();

const showDialog = ref<boolean>(false);

const emailExistsError = ref<boolean>(false);

const roles = ref<RoleResponse[]>([]);

const form = ref<UserBody>({
  firstName: "",
  lastName: "",
  email: "",
  phoneNumber: undefined,
  roleIds: []
});

const formErrors = {
  firstName: [
    (value: string) => {
      if (value?.length === 0) {
        return "Bitte gebe einen Vornamen an!";
      }
      return true;
    },
  ],
  lastName: [
    (value: string) => {
      if (value?.length === 0) {
        return "Bitte gebe einen Nachnamen an!";
      }
      return true;
    },
  ],
  email: [
    (value: string) => {
      if (value?.length === 0) {
        return "Bitte gebe eine E-Mail Adresse an!";
      }
      return true;
    },
  ],
};

function openDialog(): void {
  form.value = {
    firstName: "",
    lastName: "",
    email: "",
    phoneNumber: undefined,
    roleIds: []
  };

  showDialog.value = true;
}

function isFormInvalid(): boolean {
  const { firstName, lastName, email } = form.value;

  return firstName.length === 0 || lastName.length == 0 || email.length === 0;
}

function submitForm(): void {
  if (isFormInvalid()) {
    return;
  }
  api.users
    .createUser(form.value)
    .then(() => {
      emits("submitted");
      showDialog.value = false;
    })
    .catch((error: AxiosError) => {
      if (error?.response?.status === 409) {
        emailExistsError.value = true;
        return;
      }
      console.error(error);
    });
}

async function loadRoles(): Promise<void> {
  const { data, status, statusText } = await api.roles.getAllRoles();

  if (status !== 200) {
    console.error(statusText);
    return;
  }
  roles.value = data;
}

onMounted(loadRoles);
</script>
